/****************************************************/
/*     LCD   lcd.c              */
/* : HI-TECH XC8                          */
/****************************************************/
#include	<htc.h>
#include	"lcd.h"
/*******************************************************/
void lcd_write(char c) {
Delayus(10);
D_PIN = (c);
Delayus(1);	EN_PIN=1;Delayus(1);EN_PIN=0;
Delayus(20);
}
/*******************************************************/
void lcd_clear(void) {
RS_PIN = 0;
lcd_write(0x01);
Delayms(2);
}
/*******************************************************/
void lcd_puts(char * s) {
while(*s)   lcd_putch(*s++);
}
/*******************************************************/
void lcd_putch(char c){
RS_PIN = 1;
lcd_write(c);
}
/*******************************************************/
void lcd_gotoxy (char row, char col) {
RS_PIN = 0;
if (!row) lcd_write(0x80 | col);
else lcd_write(0xC0 | col);
}
/*******************************************************/
void lcd_init() {
RS_PIN = 0;
Delayms(15);
lcd_write(0x30);
Delayms(5);
lcd_write(0x30);
Delayus(100);
lcd_write(0x30);
Delayus(100);
lcd_write(0x38);    // 8  , 2 57 
Delayus(100);
lcd_write(0x0C);    //  ,  
lcd_write(0x06);    //    
}
/*******************************************************/
void lcd_cgram(char *arr, char adr) {
adr<<=3;
adr|=0x40;
RS_PIN = 0;
lcd_write(adr);
RS_PIN = 1;
for(i=0;i<8;i++) lcd_write(arr[i]);
RS_PIN = 0;
}
/*******************************************************/
void lcd_ram(char *arr, char len) {
RS_PIN = 1;
for(i=0;i<len;i++) lcd_write(arr[i]);
}